#!/bin/bash

# See if user is IPA user, else exit
if [[ $UID -lt {{ ipa_id_min }} || $UID -gt {{ ipa_id_max }} ]]; then
    return
fi

# MEMBER_GROUPS=`id -G`

link_if_member()
{
    local MOUNT_DIR="$1"
    local LINK_DIR="$2"

    HAS_ACCESS=0
    RIGHTS=`stat -c "%A" "$MOUNT_DIR"`
    if [[ ${RIGHTS:7:1} == 'r' && ${RIGHTS:9:1} == 'x' ]]; then
        HAS_ACCESS=1
    else
        OWNER_GROUP=`stat -c "%g" "$MOUNT_DIR"`
        for GR in `id -G`; do
            if [[ $GR -eq $OWNER_GROUP ]]; then
                HAS_ACCESS=1
                break
            fi
        done
    fi
    if [ $HAS_ACCESS -eq 1 ]; then
        if [ ! -h "$LINK_DIR" ]; then
            ln -s "$MOUNT_DIR" "$LINK_DIR"
        fi
    else
        if [ -h "$LINK_DIR" ]; then
            rm "$LINK_DIR"
        fi
    fi
}



# Add some kind of check so that script is not run too often
# Only if it was more than an hour since last time (use dot-file for this) or if script is newer than dot-file

while :
do
    BASE_DIR="$HOME/network"
    MOUNTS_DIR="/mnt/internal"

    # See if /mnt/internal is available...
    if [ ! -d "$MOUNTS_DIR" ]; then
        break
    fi

    # Create ~/network dir
    if [ ! -d "$BASE_DIR" ]; then
        mkdir -p "$BASE_DIR"
    fi

    if [ ! -e "$BASE_DIR/.desktop" ]; then
        cat <<EOF > "$BASE_DIR/.directory"
[Desktop Entry]
Icon=network-server
EOF
    fi

    # Create symlink to user home folder
    HOME_MOUNT="$MOUNTS_DIR/home/$USER"
    HOME_LINK="$BASE_DIR/$USER"
    if [ ! -h "$HOME_LINK" ]; then
        ln -s "$HOME_MOUNT" "$HOME_LINK"
    fi

    if [ ! -e "$HOME_LINK/.directory" ]; then
        cat <<EOF > "$HOME_LINK/.directory"
[Desktop Entry]
Icon=user-home
EOF
    fi

    # Go through all the user's groups and store the IPA groups in a data structure
    if [ ! -d "$BASE_DIR/grupper" ]; then
        mkdir "$BASE_DIR/grupper"
    fi
    if [ ! -e "$BASE_DIR/grupper/.directory" ]; then
       cat <<EOF > "$BASE_DIR/grupper/.directory"
[Desktop Entry]
Icon=folder-image-people
EOF
    fi

    # Go through /mnt/internal/group
    # For each subdir - if user is member of the group that owns the dir - create symlink to it
    for DIR in `ls "$MOUNTS_DIR/group/"`; do
        link_if_member "$MOUNTS_DIR/group/$DIR" "$BASE_DIR/grupper/$DIR"
    done

    # For all other dirs, if user is member of owning group or if it's world readable and executeable
    # Create symlink to it

    for DIR in `ls "$MOUNTS_DIR/"`; do
        if [[ "$DIR" != "home" && "$DIR" != "group" ]]; then
            if [[ "$DIR" == "photo" ]]; then
                LINK_DIR="foto"
            elif [[ "$DIR" == "photoalbum" ]]; then
                LINK_DIR="fotoram"
            elif [[ "$DIR" == "music" ]]; then
                LINK_DIR="musik"
            else
                LINK_DIR="$DIR"
            fi

            link_if_member "$MOUNTS_DIR/$DIR" "$BASE_DIR/$LINK_DIR"
            unset LINK_DIR
        fi
    done

    break
done

unset BASE_DIR MOUNTS_DIR HOME_MOUNT HOME_LINK DIR
unset -f link_if_member
